/* Initng, a next generatind sysvinit replacement.
 * Copyright (C) 2005 neuron <neuron@hollowtube.mine.nu>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include "../../src/initng.h"


#include <stdio.h>
#include <stdlib.h>                         /* free() exit() */
#include <string.h>
#include <unistd.h>
#include "../../src/initng_handler.h"
#include "../../src/initng_global.h"
#include "../../src/initng_plugin_hook.h"
#include "../../src/initng_common.h"
#include "../../src/initng_toolbox.h"
#include "../../src/initng_static_data_id.h"

#include "initng_reload.h"

#define SAVE_FILE "/tmp/active_db_save"

s_command FAST_RELOAD =
    { 'c', "hot_reload", TRUE_OR_FALSE_COMMAND, NO_OPT,
{(void *) &cmd_fast_reload},
"Fast Reload"
};



static void read_adb_file(void)
{
    FILE *fil;
    active_h *new_entry = NULL;
    data_save_struct entry;

    fil = fopen(SAVE_FILE, "r");

    if (!fil)
        return;

    while (!feof(fil))
    {
        if (!fread(&entry, sizeof(entry), 1, fil))
            continue;

        if (active_db_find_by_name(entry.name))
        {
            W_("Entry exists, wont create it!\n");
            continue;
        }

        if (!(new_entry = active_db_new(i_strdup(entry.name))))
        {
            F_("Cant create new active!\n");
            continue;
        }
        new_entry->a_status = entry.a_status;
        new_entry->time_got_status = entry.time_got_status;

        if (entry.p_pid)
        {
            process_db_new(&(new_entry->start_process), T_START);
            if (new_entry->start_process)
            {
                new_entry->start_process->pid = entry.p_pid;
                new_entry->start_process->stdout[0] = entry.stdout1;
                new_entry->start_process->stdout[1] = entry.stdout2;
            }
        }

        if (!active_db_add(new_entry))
        {
            F_("Coud not add entry!\n");
            active_db_free(new_entry);
            continue;
        }
        W_("Added from " SAVE_FILE ": %s\n", entry.name);
    }

    fclose(fil);
    if (unlink(SAVE_FILE) != 0)
    {
        W_("Failed removing file " SAVE_FILE " !!!\n");
        return;
    }
}

static void cmd_fast_reload(char *arg, FILE * fd)
{
    FILE *fil;
    active_h *current = g.active_database;
    data_save_struct entry;

    (void) arg;

    fil = fopen(SAVE_FILE, "w+");


    while (current)
    {
        if (strlen(current->name) >= 199)
        {
            F_("Service name is to long, it wont fit the fileformat spec!, wont save this service!\n");
            continue;
        }
        strcpy(entry.name, current->name);
        entry.a_status = current->a_status;
        entry.time_got_status = current->time_got_status;
        if (current->start_process)
        {
            entry.p_pid = current->start_process->pid;
            entry.stdout1 = current->start_process->stdout[0];
            entry.stdout2 = current->start_process->stdout[1];
        }
        else
        {
            entry.p_pid = 0;
            entry.stdout1 = 1;
            entry.stdout2 = 2;
        }

        printf("Saving : %s\n", entry.name);
        fwrite(&entry, sizeof(entry), 1, fil);
        current = current->next;
    }

    fclose(fil);
    {
        int i;

        for (i = 0; i < 100; i++)
        {
            fprintf(fd, "RESTARTING\n");
            usleep(100);
        }
    }


    {

        char *new_argv[] =
            { i_strdup("/sbin/initng"), i_strdup("--hot_reload"), NULL };
        execve("/sbin/initng", new_argv, environ);
    }
    F_("Failed to reload initng!\n");
}

int module_init(const char *version)
{
    D_("module_init(reload);\n");
    if (strcmp(version, INITNG_VERSION) != 0)
    {
        F_("This module, is compiled for \"%s\" version, and initng is compiled on \"%s\" version, wont load this module!\n", INITNG_VERSION, version);
        return (FALSE);
    }

    read_adb_file();
    initng_command_add(&FAST_RELOAD);
    return (TRUE);
}

void module_unload(void)
{
    D_("module_unload();\n");
    initng_command_del(&FAST_RELOAD);
}
