
/* Initng, a next generation sysvinit replacement.
 * Copyright (C) 2005 Jimmy Wennlund <jimmy.wennlund@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef INITNG_H
#define INITNG_H

#ifdef HAVE_CONFIG_H
#   include <config.h>
#endif

#define _GNU_SOURCE
#include <stdio.h>                          /* printf */
#include "initng_error.h"

/* default version string to show */
#define INITNG_VERSION  VERSION " Now, lets go bughunt ! "


/* unset this in an pruduction environment */
/* this is set in config.h */
/*#define DEBUG */

/* specify paths */
#define INITNG_ROOT     "/etc/initng"
#define INITNG_PLUGIN_DIR "/lib/initng"
#define STD_OUT         "/dev/vc/12"
#define STD_OUT2        "/dev/tty12"
#define STD_ERR         "/dev/console"
#define INITNG_EXT      ".i"

/* set maximums */
#define MAX_DATA_TYPES  50
#define MAX_COMMANDS    50
#define MAX_VERBOSES    50
#define MAX_BLACKLIST   20

/* save this many entrys in history */
#define HISTORY         400

/* after term is sent, wait these seconds before killing */
#define SECONDS_BEFORE_KILL 2

/* makes all services sleep this many microseconds before launcinh,
 * this will get initng time to register service */
#define ALL_USLEEP 1000

/*
 * Temporary printf-replacement macros until a real logging system can be added.
 */
#define F_(fmt, ...) \
    print_error(MSG_FAIL, __FILE__, __func__, __LINE__, fmt, ## __VA_ARGS__);

#define W_(fmt, ...) \
    print_error(MSG_WARN, __FILE__, __func__, __LINE__, fmt, ## __VA_ARGS__);

#ifdef DEBUG
#define V_ADD(to_verb) s_set_another_string(VERBOSE_THIS, to_verb)
#define D_(fmt, ...) \
    print_error(MSG_VERBOSE, __FILE__, __func__, __LINE__, fmt, ## __VA_ARGS__);
#else
#define D_(fmt, ...)
#endif


#define TRUE    1
#define FALSE   0
#define FAIL    -1

#endif
