
/* Initng, a next generation sysvinit replacement.
 * Copyright (C) 2005 Jimmy Wennlund <jimmy.wennlund@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include "initng.h"
#include "initng_active_status.h"

const char *active_status_string[] = {
    "STATUS_NONE",
    "STATUS_LOADING",
    "STATUS_STARTING",
    "STATUS_WAITING_FOR_START_DEP",
    "STATUS_START_DEP_MET",
    "STATUS_FAIL_STARTING",
    "STATUS_START_DEP_FAILED",
    "STATUS_LAUNCING",
    "STATUS_WAITING_FOR_PID_FILE",
    "STATUS_RUNNING",
    "STATUS_DONE",
    "STATUS_RESPAWNING",
    "STATUS_STOPPING",
    "STATUS_WAITING_FOR_STOP_DEP",
    "STATUS_STOP_DEP_MET",
    "STATUS_STOP_DEP_FAILED",
    "STATUS_FAIL_STOPPING",
    "STATUS_STOP_LAUNCING",
    "STATUS_STOPPED",
    "STATUS_STOP_MARKED",
    "STATUS_RESTARTING",
    NULL
};



/* returns a string with status name for nice output */
const char *active_db_get_status_string(e_a_status status)
{
    unsigned int i;

    /* step thru the db, to make sure status is now overflow */
    for (i = 0; active_status_string[i]; i++)
        if (i == status)
            return (active_status_string[status]);

    return (NULL);
}
