
/* Initng, a next generation sysvinit replacement.
 * Copyright (C) 2005 Jimmy Wennlund <jimmy.wennlund@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include "initng.h"

#include "initng_history.h"
#include "initng_active_status.h"
#include "initng_global.h"
#include "initng_toolbox.h"
#include <sys/types.h>                      /* time_t */
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <stdio.h>                          /* printf() */
#include <assert.h>
int counter = 0;

                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   /* this walks the db, and update the timings, if system clock changes *//*history_h **history_db = NULL; *//* a big list of pointers pointing to all known history structs */
void history_db_compensate_time(time_t skew)
{
    history_h *current = g.history_db;

    D_("history_db_compensate_time(%i);\n", (int) skew);

    while (current)
    {
        if (current->time)
            current->time += skew;

        current = current->next;
    }
}

                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           /* this walks the db, and clears particular services *//*history_h **history_db = NULL; *//* a big list of pointers pointing to all known history structs */
void history_db_clear_service(active_h * service)
{
    history_h *current = g.history_db;

    while (current)
    {
        if (current->service == service)
        {
            current->service = NULL;
            current->name = i_strdup(service->name);
        }
        current = current->next;
    }
}

/* clear history */
void history_free_all(void)
{
    history_h *next = NULL;

    /* while there is a histry db */
    while (g.history_db)
    {
        /* save this, it will be free(); */
        next = g.history_db->next;

        /* free histry name */
        if (g.history_db->name)
            free(g.history_db->name);

        /* free histroy entry */
        free(g.history_db);

        /* make histroy_db the next one */
        g.history_db = next;
    }
}

/* add values to history database */
void history_add_values(active_h * service)
{
    history_h *tmp_e = NULL;    /* temporary pointer to insert data and add to db */

    assert(service->name);

    D_("adding: %s.\n", service->name);

    /* allocate space for data */
    if (!(tmp_e = (history_h *) initng_calloc(1, sizeof(history_h))))
    {
        F_("history_add_values(): Out of memory.\n");
        return;
    }

    /* set data in struct */
    tmp_e->service = service;
    tmp_e->name = NULL;
    tmp_e->time = service->time_got_status;
    tmp_e->action = service->a_status;
    tmp_e->next = NULL;
    tmp_e->prev = NULL;

    /* add struct */
    history_add(tmp_e);

    /* leave */
    return;
}

/* add to history space */
void history_add(history_h * entry)
{
    history_h *current = g.history_db;

    /* dumb check */
    assert(entry);


    if (!g.history_db)
    {
        D_("This is the first history entry.\n");
        g.history_db = entry;
        return;
    }

    while (current)
    {
        if (current->service && current->service == entry->service)
        {
            if (current->action == entry->action)
            {
                D_("This is allredy set, check this out!\n");
                D_("Service: %s, action %s\n", current->service->name,
                   active_db_get_status_string(current->action));
                free(entry);
                return;
            }
            else
                break;
        }
        current = current->next;
    }

    /* add the chain to the end of enry servie */
    entry->next = g.history_db;
    entry->prev = g.history_db->prev;
    g.history_db->prev = entry;
    /* set this as the history_db */
    g.history_db = entry;
    if (!g.history_db->prev)
        g.history_db->prev = g.history_db->next;

    counter++;

    /* it can grow to big */
    if (counter >= HISTORY)                 /* remove 10 when doing it */
    {
        history_h *last = g.history_db->prev;

        /* jump to end */
        if (last)
        {
            if (last->name)
                free(last->name);

            /* dont link to this */
            last->prev->next = NULL;

            /* save last link */
            g.history_db->prev = last->prev;

            /* free the entry at end */
            free(last);

            /* it one less now */
            counter--;
        }
    }
    return;
}

/* returns the time in seconds, sense history entry name, switched to status from */
int time_been_from(active_h * service, e_a_status from)
{
    history_h *current = g.history_db;
    time_t from_t = 0;
    time_t time_now = time(0);

    assert(service);

    /* check if history_db exists */
    if (!g.history_db)
    {
        D_("History db is empty, returning 0\n");
        return (0);
    }

    while (current)
    {
        if (current->service == service)
        {
            if (current->action == from)
                from_t = current->time;
        }
        current = current->next;
    }

    /* if now time is greater, more then last time (???) */

    if (from_t && time_now > from_t)
        return ((int) time_now - (int) from_t);
    else
        return (0);

}
