
/* Initng, a next generation sysvinit replacement.
 * Copyright (C) 2005 Jimmy Wennlund <jimmy.wennlund@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include "initng.h"

#include <sys/types.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <alloca.h>
#include "initng_process_db.h"
#include "initng_toolbox.h"

/* creates a process_h struct with defaults */
void process_db_new(process_h ** new_p, e_pt type)
{
    /* allocate a new process entry */
    *new_p = (process_h *) initng_calloc(1, sizeof(process_h)); /* Allocate memory for a new process */

    (*new_p)->pt = type;

    /* null pid */
    (*new_p)->pid = 0;

    /* reset returncode */
    /* XXX: magic number - what does it mean? */
    (*new_p)->r_code = -10;

    /* open pipe */
    if (pipe((*new_p)->stdout) != 0)
    {
        F_("Failed adding pipe ! %s\n", strerror(errno));
        sleep(2);
    }

    /* alloc buffer */
    (*new_p)->buffer = initng_calloc(MAX_BUFFER + 1, 1);
    (*new_p)->buffer_pos = 0;

}

/* function to free a process_h struct */
void process_db_free(process_h ** free_this)
{
    if (!*free_this)
        return;

    if ((*free_this)->stdout[0] > 0)
        close((*free_this)->stdout[0]);
    if ((*free_this)->stdout[1] > 0)
        close((*free_this)->stdout[1]);
    if ((*free_this)->buffer)
        free((*free_this)->buffer);

    free(*free_this);
    *free_this = NULL;
    return;
}
